{*********************************************************}
{                                                         }
{       Demo:                                             }
{       Sending HTML Email using TRichView editor and     }
{       CleverComponents                                  }
{                                                         }
{       TRichView (c) Sergey Tkachenko                    }
{       http://www.trichview.com                          }
{       Clever Components (c) Clever Components Team      }
{       http://www.clevercomponents.com                   }
{                                                         }
{*********************************************************}

{
  This demo uses SendHTMLEmail procedure from clRVSendMail.pas
}

unit main;

interface

{$I RV_Defs.inc}

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, clMailMessage, clPOP3, clMC, clSMTP,
  clTcpClient, RVStyle, RVScroll, RichView, RVEdit, clRVSendMail;

type
  TForm1 = class(TForm)
    clSMTP1: TclSMTP;
    clMailMessage1: TclMailMessage;
    btnSend: TButton;
    RichViewEdit1: TRichViewEdit;
    RVStyle1: TRVStyle;
    GroupBox1: TGroupBox;
    Label2: TLabel;
    Label3: TLabel;
    Label5: TLabel;
    edtUser: TEdit;
    edtPassword: TEdit;
    edtSmtpServer: TEdit;
    GroupBox2: TGroupBox;
    Label1: TLabel;
    Label4: TLabel;
    Label6: TLabel;
    edtFrom: TEdit;
    edtSubject: TEdit;
    edtTo: TEdit;
    procedure btnSendClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure FillDefaults;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

{------------------------------------------------------------------------------}
// Sending
procedure TForm1.btnSendClick(Sender: TObject);
begin
  if clSMTP1.Active then Exit;
  btnSend.Enabled := False;
  try
      clMailMessage1.From.FullAddress := edtFrom.Text;
      clMailMessage1.ToList.EmailAddresses := edtTo.Text;
      clMailMessage1.Subject := edtSubject.Text;

      clSMTP1.Server := edtSmtpServer.Text;
      clSMTP1.UserName := edtUser.Text;
      clSMTP1.Password := edtPassword.Text;

      SendHTMLEmail(RichViewEdit1, clSMTP1, clMailMessage1);

      ShowMessage('The message was sent successfully');
  finally
    btnSend.Enabled := True;
  end;
end;

procedure TForm1.FillDefaults;
begin
{
  edtUser.Text := '...';
  edtPassword.Text := '...';
  edtSmtpServer.Text := '...';
  edtFrom.Text := '...';
  edtTo.Text := '...';
  edtSubject.Text := '...';
}
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
FillDefaults;
end;

end.
