{*********************************************************}
{                                                         }
{       Demo:                                             }
{       Sending HTML Email using TRichView editor and     }
{       CleverComponents                                  }
{                                                         }
{       TRichView (c) Sergey Tkachenko                    }
{       http://www.trichview.com                          }
{       Clever Components (c) Clever Components Team      }
{       http://www.clevercomponents.com                   }
{                                                         }
{*********************************************************}

{
  This demo uses ComposeAndSendHTMLEmail function from clRVSendDialog.pas
}

unit main;

interface

{$I RV_Defs.inc}

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls,
  {$IFDEF RICHVIEWDEF2009}
  PngImage,
  {$ENDIF}
  {$IFDEF RICHVIEWDEF2007}
  GifImg, RVGifAnimate2007,
  {$ENDIF}
  clMailMessage, clPOP3, clMC, clSMTP, clTcpClient,
  RVStyle, RVScroll, RichView, RVEdit, CRVData,
  clRVSendDialog, ComCtrls;


type
  TForm1 = class(TForm)
    clSMTP1: TclSMTP;
    clMailMessage1: TclMailMessage;
    btnSend: TButton;
    GroupBox1: TGroupBox;
    Label2: TLabel;
    Label3: TLabel;
    Label5: TLabel;
    edtUser: TEdit;
    edtPassword: TEdit;
    edtSmtpServer: TEdit;
    ProgressBar1: TProgressBar;
    Label1: TLabel;
    procedure btnSendClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure clSMTP1Progress(Sender: TObject; ABytesProceed,
      ATotalBytes: Int64);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure FillDefaults;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

{------------------------------------------------------------------------------}
// Sending
procedure TForm1.btnSendClick(Sender: TObject);
begin
  if clSMTP1.Active then
    Exit;
  btnSend.Enabled := False;
  try
    clSMTP1.Server := edtSmtpServer.Text;
    clSMTP1.UserName := edtUser.Text;
    clSMTP1.Password := edtPassword.Text;
    ProgressBar1.Position := 0;
    ProgressBar1.Visible := True;
    Label1.Visible := True;
    if ComposeAndSendHTMLEmail(clSMTP1, clMailMessage1) then
      ShowMessage('The message was sent successfully');
  finally
    btnSend.Enabled := True;
    ProgressBar1.Visible := False;
    Label1.Visible := False;
  end;
end;

procedure TForm1.clSMTP1Progress(Sender: TObject; ABytesProceed,
  ATotalBytes: Int64);
begin
  if ATotalBytes<>0 then
    ProgressBar1.Position := Round(ABytesProceed / ATotalBytes * 100)
  else
    ProgressBar1.Position := 100;
end;

procedure TForm1.FillDefaults;
begin
{
  edtUser.Text := '...';
  edtPassword.Text := '...';
  edtSmtpServer.Text := '...';
  edtFrom.Text := '...';
  edtTo.Text := '...';
  edtSubject.Text := '...';
}
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 {$IFDEF RICHVIEWDEF2007}
 RegisterClass(TGifImage);
 RV_RegisterHTMLGraphicFormat(TGifImage);
 {$ENDIF}
 {$IFDEF RICHVIEWDEF2009}
 RegisterClass(TPngImage);
 RV_RegisterHTMLGraphicFormat(TPngImage);
 RV_RegisterPngGraphic(TPngImage);
 {$ENDIF}
 FillDefaults;
end;

end.
